;; Triangle, pentagonal, and hexagonal numbers are generated by the following formulae:
;; Triangle   Tn=n(n+1)/2   1, 3, 6, 10, 15, ...
;; Pentagonal   Pn=n(3n-1)/2   1, 5, 12, 22, 35, ...
;; Hexagonal   Hn=n(2n-1)   1, 6, 15, 28, 45, ...

;; It can be verified that T285 = P165 = H143 = 40755.

;; Find the next triangle number that is also pentagonal and hexagonal.

(defun triangle (num)
  (/ (* num (+ num 1)) 2))

(defun pentagonal (num)
  (/ (* num 
	(- (* 3 num) 1))
     2))

(defun hexagonal (num)
  (* num 
     (- (* 2 num) 1)))

(defun find-next-triangle-number ()
  (let* ((ttI 1)
	 (tt (triangle ttI))
	 (ppI 1)
	 (pp (pentagonal ppI))
	 (hhI 1)
	 (hh (hexagonal hhI)))
    (loop 
     ;; repeat 3000
     do
     (loop 
      while (> tt pp)
      do
      (setf pp (pentagonal (incf ppI))))
     (loop
      while (> tt hh)
      do
      (setf hh (hexagonal (incf hhI))))
     ;;(format t "tt:~a pp:~a hh:~a~&" tt pp hh)
     (when (= tt pp hh)
       (format t "found:~a~&" tt)
       (when (> tt 40755)
	 (return-from find-next-triangle-number tt)))
     (setf tt (triangle (incf ttI))))))

;; (time (find-next-triangle-number))

;; 1533776805